//+------------------------------------------------------------------+
//|                                              Exchange_CTrade.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <Trade\PositionInfo.mqh>
#include <Trade\Trade.mqh>
//--- global variable
CPositionInfo  m_position;                   // trade position object
CTrade         m_trade;                      // trading object
bool     IN=true;
bool     OUT=true;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   SymbolSelect("EURJPY",true);
   SymbolSelect("USDJPY",true);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   double open_EURJPY=iOpen(0,"EURJPY",PERIOD_M30);
   double open_USDJPY=iOpen(0,"USDJPY",PERIOD_M30);
   if(IN)
     {
      if(TimeCurrent()>D'2016.08.13 19:00:00')
        {
         datetime date=TimeCurrent();
         IN=false;
         m_trade.Sell(1.00,"EURJPY");
         m_trade.Buy(0.76,"USDJPY");
        }
     }
   if(OUT)
     {
      if(TimeCurrent()>D'2016.09.16 15:00:00')
        {
         datetime date=TimeCurrent();
         OUT=false;
         for(int i=PositionsTotal()-1;i>=0;i--)
           {
            if(m_position.SelectByIndex(i))
              {
               Print("Start Close");
               m_trade.PositionClose(m_position.Ticket());
               uint     retcode             = m_trade.ResultRetcode();
               string   retcode_description = m_trade.ResultRetcodeDescription();
               string   comment             = m_trade.ResultComment();
               Print("End close. Ticket ",m_position.Ticket(),
                     ": Retcode ",retcode,
                     ", RetcodeDescription ",retcode_description,
                     ", Comment ",comment);
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+ 
//| Get Open for specified bar index                                 | 
//+------------------------------------------------------------------+ 
double iOpen(const int index,string symbol=NULL,ENUM_TIMEFRAMES timeframe=PERIOD_CURRENT)
  {
   if(symbol==NULL)
      symbol=Symbol();
   if(timeframe==0)
      timeframe=Period();
   double Open[];
   double open=0;
   ArraySetAsSeries(Open,true);
   int copied=CopyOpen(symbol,timeframe,index,1,Open);
   if(copied>0) open=Open[0];
   return(open);
  }
//+------------------------------------------------------------------+
